package cn.jyjz.xiaoyao.common.mybatisplus.util;

import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQueryConstant;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQueryForm;
import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.commons.lang3.StringUtils;

/**
 * @author zhangyong
 * @title: SearchQueryFormat
 * @projectName jyjz-parent
 * @description: TODO
 * @date 2021/11/133 PM
 */
public class SearchQueryFormat {
    private static String formatAlias(BaseDto obj,String alias,Map.Entry<String,Object> entry){
        if("listdept".equals(entry.getKey())){
            return obj.getQueryFiled(entry.getKey());
        }else{
            return alias + obj.getQueryFiled(entry.getKey().toUpperCase());
        }
    }

    /**
     * 格式化排序
     * @param queryWrapper
     * @param <T>
     * @return
     */
    /**
     * 格式化排序
     * @param queryWrapper 搜索对象
     * @param sortname 排序字段
     * @param sortorder 排序方式
     * @return
     */
    public static<T> void queryStringFormat(QueryWrapper queryWrapper,String sortname,String sortorder) {

        if(null != queryWrapper){

            if(sortname.toUpperCase().equals("DESC")){
                queryWrapper.orderByDesc(sortname);
            }else if(sortname.toUpperCase().equals("ASC")){
                queryWrapper.orderByAsc(sortname);
            }
        }

    }
    public static<T> QueryWrapper<T> queryStringFormat(SearchQuery searchQuery,BaseDto obj,String alias) {
        QueryWrapper<T> queryWrapper = new QueryWrapper<T>();

        Map<String, Object> query = null;
        if(null == searchQuery){
            query = new HashMap();
        }else{
            query = searchQuery.getQuery();
        }

        SearchQuery searchQueryUser = obj.getSearchQueryrolesShowleave();
        if(null != searchQueryUser){
            Map<String, Object> queryUser = searchQueryUser.getQuery();
            query.putAll(queryUser);
        }


        for(Map.Entry<String,Object> entry:query.entrySet()){
            SearchQueryForm searchQueryForm = (SearchQueryForm) entry.getValue();

            if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_EQUAL)){

                queryWrapper.eq(formatAlias(obj,alias,entry),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_LIKE)){

                queryWrapper.like(formatAlias(obj,alias,entry),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_EQUAL_NOT)){

                queryWrapper.ne(formatAlias(obj,alias,entry),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_GREATER)){

                queryWrapper.gt(formatAlias(obj,alias,entry),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_GREATER_EQUAL)){

                queryWrapper.ge(formatAlias(obj,alias,entry),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_LESS)){

                queryWrapper.lt(formatAlias(obj,alias,entry),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_LESS_EQUAL)){

                queryWrapper.le(formatAlias(obj,alias,entry),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_IN)){

                List object = (List) searchQueryForm.getValue();

                if(null != object && object.size() > 0){

                    if (object.get(0).getClass().getName().equals("java.lang.String")) {
                        List<String> list = (List<String>) searchQueryForm.getValue();

                        queryWrapper.in(obj.getQueryFiled(entry.getKey()), list);
                    } else if (object.get(0).getClass().getName().equals("java.lang.Long")) {
                        List<Long> list = (List<Long>) searchQueryForm.getValue();

                        queryWrapper.in(obj.getQueryFiled(entry.getKey()), list);
                    } else {
                        queryWrapper.in(obj.getQueryFiled(entry.getKey().toUpperCase()), object);
                    }
                }
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_NOTIN)){

                queryWrapper.notIn(formatAlias(obj,alias,entry),searchQueryForm.getValue());
            }

        }

        return queryWrapper;
    }
    public static<T> QueryWrapper<T> queryStringFormat(SearchQuery searchQuery,BaseDto obj) {
        QueryWrapper<T> queryWrapper = new QueryWrapper<T>();

        Map<String, Object> query = null;
        if(null == searchQuery){
            query = new HashMap();
        }else{
            query = searchQuery.getQuery();
        }


        SearchQuery searchQueryUser = obj.getSearchQueryrolesShowleave();
        if(null != searchQueryUser){
            Map<String, Object> queryUser = searchQueryUser.getQuery();
            query.putAll(queryUser);
        }


        for(Map.Entry<String,Object> entry:query.entrySet()){
            SearchQueryForm searchQueryForm = (SearchQueryForm) entry.getValue();

            if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_EQUAL)){

                queryWrapper.eq(obj.getQueryFiled(entry.getKey().toUpperCase()),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_LIKE)){

                queryWrapper.like(obj.getQueryFiled(entry.getKey().toUpperCase()),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_EQUAL_NOT)){

                queryWrapper.ne(obj.getQueryFiled(entry.getKey().toUpperCase()),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_GREATER)){

                queryWrapper.gt(obj.getQueryFiled(entry.getKey().toUpperCase()),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_GREATER_EQUAL)){

                queryWrapper.ge(obj.getQueryFiled(entry.getKey().toUpperCase()),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_LESS)){

                queryWrapper.lt(obj.getQueryFiled(entry.getKey().toUpperCase()),searchQueryForm.getValue());
            }else if(StringUtils.isNotBlank(searchQueryForm.getOp())
                && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_LESS_EQUAL)){

                queryWrapper.le(obj.getQueryFiled(entry.getKey().toUpperCase()),searchQueryForm.getValue());
            }else {
                if (StringUtils.isNotBlank(searchQueryForm.getOp())
                    && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_IN)) {
                    List object = (List) searchQueryForm.getValue();

                    if(null != object && object.size() > 0){

                        if (object.get(0).getClass().getName().equals("java.lang.String")) {
                            List<String> list = (List<String>) searchQueryForm.getValue();

                            queryWrapper.in(obj.getQueryFiled(entry.getKey()), list);
                        } else if (object.get(0).getClass().getName().equals("java.lang.Long")) {
                            List<Long> list = (List<Long>) searchQueryForm.getValue();

                            queryWrapper.in(obj.getQueryFiled(entry.getKey()), list);
                        } else {
                            queryWrapper.in(obj.getQueryFiled(entry.getKey().toUpperCase()), object);
                        }
                    }


                } else if (StringUtils.isNotBlank(searchQueryForm.getOp())
                    && searchQueryForm.getOp().equals(SearchQueryConstant.SEARCH_NOTIN)) {

                    queryWrapper.notIn(obj.getQueryFiled(entry.getKey().toUpperCase()),
                        searchQueryForm.getValue());
                }
            }

        }

        return queryWrapper;
    }

}
