package cn.jyjz.xiaoyao.createcode;


import cn.jyjz.xiaoyao.createcode.createcode.CreateCodeFactory;
import cn.jyjz.xiaoyao.createcode.object.Table;
import cn.jyjz.xiaoyao.createcode.read.XmlPrase;
import java.util.List;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by zhangyong on 2018/5/16.
 */
public class CreateCode {

    private Logger logger = LoggerFactory.getLogger(this.getClass());

    /**
     * 生成代码
     * @param pdmpath 不同的参数类型的pom配置也不同
     * @param codepath 工程代码生成物理路径
     * @param javapath java代码生成的相对了路径
     * @param htmlpath 页面代码生成相对路径
     * @param mapperpath mapperpath代码想成的相对路径
     */
    public void createCode(String pdmpath,String codepath,String javapath,String htmlpath,String mapperpath){
        logger.info("pdm路径："+pdmpath + ",代码生成路径" +codepath);

        if(StringUtils.isNotBlank(pdmpath)
            && StringUtils.isNotBlank(codepath) && StringUtils.isNotBlank(javapath)
            && StringUtils.isNotBlank(htmlpath) && StringUtils.isNotBlank(mapperpath)){
            XmlPrase xp = new XmlPrase();
            List<Table> listTable = xp.getXmlTable(pdmpath);


            if(CreateCodeFactory.createcode(codepath,listTable,javapath, htmlpath, mapperpath)){
                logger.info("代码生成完毕。");
            }else {
                logger.info("解析文件失败。");
            }
        }else{
            logger.info("路径输入错误。");
        }
    }
    public static void main(String[] args){
        String pdmpath = "D:\\ideaWork\\jeecg\\ocrproject\\runstart\\doc\\sql\\oa.pdm";
        String codepath = "C:\\Users\\ThinkPad\\Desktop\\test";
        String javapath = "cn/jyjz/xiaoyao/ocrnewtest";
        String htmlpath = "backstage/ocrnewtest";
        String mapperpath= "mapper";

        CreateCode createCode = new CreateCode();
        createCode.createCode(pdmpath,codepath,javapath,htmlpath,mapperpath);
    }
}
