package cn.jyjz.xiaoyao.createcode.createcode.java;

import cn.jyjz.xiaoyao.createcode.createcode.java.htmlcode.CreateAdd;
import cn.jyjz.xiaoyao.createcode.createcode.java.htmlcode.CreateEdit;
import cn.jyjz.xiaoyao.createcode.createcode.java.htmlcode.CreateList;
import cn.jyjz.xiaoyao.createcode.createcode.java.javacode.CreateController;
import cn.jyjz.xiaoyao.createcode.createcode.java.javacode.CreateDataDao;
import cn.jyjz.xiaoyao.createcode.createcode.java.javacode.CreateMapper;
import cn.jyjz.xiaoyao.createcode.createcode.java.javacode.CreateModel;
import cn.jyjz.xiaoyao.createcode.createcode.java.javacode.CreateService;
import cn.jyjz.xiaoyao.createcode.object.Table;
import cn.jyjz.xiaoyao.createcode.util.ForFileUtil;
import java.io.File;
import java.io.IOException;
import java.util.List;

/**
 * Created by zhangyong on 2018/2/7.
 */
public class CreateJava {

    private String projecpath;
    private List<Table> listtable;
    private String javapath;
    private String htmlpath;
    private String mapperpath;

    /**
     * 初始化
     * @param projecpath 工程存放路径
     * @param listtable pdm表集合
     * @param javapath java代码相对projecpath的路径
     * @param htmlpath jsp代码相对projecpath的路径
     * @param mapperpath mapper代码相对projecpath的路径
     */
    public CreateJava(String projecpath, List<Table> listtable,
                      String javapath,String htmlpath,String mapperpath){

        this.projecpath = projecpath;
        this.listtable = listtable;
        this.javapath = javapath;
        this.htmlpath = htmlpath;
        this.mapperpath = mapperpath;
    }
    public boolean createCode()
    {

        for(Table table:listtable){

            boolean ismodel = CreateModel
                .createModel(this.projecpath + File.separator + "java",table,javapath,htmlpath);
            boolean isdao = CreateDataDao
                .createDao(this.projecpath + File.separator + "java",table,javapath,htmlpath);
            boolean isservice = CreateService
                .createService(this.projecpath + File.separator + "java",table,javapath,htmlpath);
            String sql = CreateController
                .createController(this.projecpath + File.separator + "java",table,javapath,htmlpath);
            boolean ismapper = CreateMapper
                .createModel(this.projecpath + File.separator + "resources",table,mapperpath,javapath,htmlpath);

            //页面
            boolean islist = CreateList
                .createList(this.projecpath + File.separator + "webapp",table,htmlpath);
            boolean isadd = CreateAdd
                .createList(this.projecpath + File.separator + "webapp",table,htmlpath);
            boolean isedit = CreateEdit
                .createList(this.projecpath + File.separator + "webapp",table,htmlpath);

            //创建sql文件
            try {
                ForFileUtil
                    .writeFileContent(this.projecpath + File.separator + "insert_resource.sql",sql);
            } catch (IOException e) {
                e.printStackTrace();
                return false;
            }
        }


        //获取table对象集合
//        var temptables:XMLList = tables.child("table");
//        for(var i:int = 0;i < temptables.length();i++){
//        var temptablexml:XML = new XML(temptables[i].toString());
//        //生成单表的controller、service、dao、model
//        createAllCode(temptablexml);

        return true;
    }


}
