package cn.jyjz.xiaoyao.createcode.createcode.java.htmlcode;

import cn.jyjz.xiaoyao.createcode.createcode.java.javacode.CreateController;
import cn.jyjz.xiaoyao.createcode.object.Column;
import cn.jyjz.xiaoyao.createcode.object.Table;
import cn.jyjz.xiaoyao.createcode.util.ForFileUtil;
import java.io.File;
import java.io.IOException;
import java.util.List;
import org.apache.commons.lang3.StringUtils;

/**
 * Created by zhangyong on 2018/3/2.
 */
public class CreateList {

    /**
     *
     * physicspath：文件实际保存路径
     * table 数据库表对象
     * htmlpath html存储路径
     *
     * */
    public static boolean createList(String physicspath, Table table, String htmlpath){

        htmlpath = htmlpath.replace("/",File.separator);

        if(htmlpath.endsWith(File.separator)){
            htmlpath = htmlpath.substring(0,htmlpath.length()-1);
        }

        //去掉路径上第一个分隔符
        if(htmlpath.startsWith(File.separator)){
            htmlpath = htmlpath.substring(1,htmlpath.length());
        }

        if(!physicspath.endsWith(File.separator)){
            physicspath = physicspath + File.separator;
        }

        //输出内容
        StringBuffer modeldata = new StringBuffer();

        //创建html的物理路径
        String changemodelpath = physicspath + htmlpath + File.separator  + table.getJavaName().toLowerCase() + File.separator +"list.html";

        modeldata.append(HtmlUtils.getListHeader(CreateController.urlFormapPath(table.getJavaName()),table.getTableName()));

        modeldata.append("</head>\n");

        modeldata.append("<body class=\"gray-bg\">\n");

        //------start

        modeldata.append("<div class=\"wrapper wrapper-content animated fadeInRight\">\n");

        //搜索开始
        modeldata.append("\t<div class=\"ibox \">\n");
        modeldata.append("\t\t<div class=\"ibox-content\">\n");
        modeldata.append("\t\t\t<div class=\"ibox-content\">\n");
        modeldata.append("\t\t\t\t<form id=\"searcheuser\" class=\"form-inline\">\n");

        modeldata.append(foramatSearch(table.getColumnList()));//搜索

        modeldata.append("\t\t\t\t\t<div class=\"form-group\">\n");
        modeldata.append("\t\t\t\t\t<a class=\"btn btn-primary btn-rounded btn-sm\" onclick=\"refreshTable()\"><i class=\"fa fa-search\"></i>&nbsp;搜索</a>\n");
        modeldata.append("\t\t\t\t\t<a class=\"btn btn-warning btn-rounded btn-sm\" onclick=\"$('#searcheuser')[0].reset()\"><i class=\"fa fa-refresh\"></i>&nbsp;重置</a>\n");
        modeldata.append("\t\t\t\t\t</div>\n");
        modeldata.append("\t\t\t\t</form>\n");
        modeldata.append("\t\t\t</div>\n");
        modeldata.append("\t\t</div>\n");
        modeldata.append("\t</div>\n");
        //搜索结束

        modeldata.append("\t<div class=\"ibox-content\">\n");
        modeldata.append("\t\t<div class=\"row row-lg\">\n");

        //功能按钮开始
        modeldata.append("\t\t\t<div class=\"col-sm-12\">\n");
        modeldata.append("\t\t\t\t<div class=\"container-div\">\n");
        modeldata.append("\t\t\t\t\t<div class=\"btn-group-sm\" id=\"_mybutton\" role=\"group\">\n");
        modeldata.append("\t\t\t\t\t</div>\n");
        modeldata.append("\t\t\t\t\t<br/>\n");
        modeldata.append("\t\t\t\t</div>\n");
        modeldata.append("\t\t\t</div>\t\n");
        //功能按钮结束

        //列表开始
        modeldata.append("\t\t\t<div class=\"col-sm-12 select-table table-striped\" >\n");
        modeldata.append("\t\t\t\t<table id=\"" + table.getJavaName() + "_list\" ></table>\n");
        modeldata.append("\t\t\t</div>\n");
        //列表结束

        modeldata.append("\t\t</div>\n");
        modeldata.append("\t</div>\n");


        modeldata.append("</div>\n");

        //------end



        modeldata.append(HtmlUtils.getBootm());

        //加载js内容

        modeldata.append("\t<script type=\"text/javascript\">\n");

        modeldata.append("\tvar _tableList" + table.getJavaName() + ";\n");

        modeldata.append("\tvar jsptoolbar = '';\n");

        modeldata.append("\tvar jspOperation = '';\n");

        //js 初始化---开始
        modeldata.append("\tjQuery(document).ready(function($){\n");

        modeldata.append("\t\tparent.axgetXiaoyao(\"${ctx}/backstage/admin/user/toolsbarOperation?\" +  \"resourceid=${resourceid}\",null,true ,\n");

        modeldata.append("\t\t\tfunction(data){\n");

        //js 初始化工具按钮--开始
        modeldata.append("\t\t\t\tif(data.code == \"OK\"){\n");

        modeldata.append("\t\t\t\t\tjsptoolbar = data.data.Jsptoolbar;\n");
        modeldata.append("\t\t\t\t\tjspOperation = data.data.JspOperation;\n");
        modeldata.append("\t\t\t\t\t$(\"#_mybutton\").empty();\n");

        modeldata.append("\t\t\t\t\t$(jsptoolbar).each(function (i, toolbar) {\n");
        modeldata.append("\t\t\t\t\t\tif(toolbar.methodid != '104'){\n");
        modeldata.append("\t\t\t\t\t\t\t$(\"#_mybutton\").append('<button class=\"btn sbold ' + toolbar.img + '\" onClick=\"' + toolbar.actionmethod + '(\\\'${resourceid}' + toolbar.methodid + '\\\')\"> ' + ' <i class=\"fa ' + toolbar.methodkey + '\"></i> ' + toolbar.text + '</button>&nbsp');\n");
        modeldata.append("\t\t\t\t\t\t}\n");
        modeldata.append("\t\t\t\t\t});\n");

        //js 初始化table列表--开始
        modeldata.append("\t\t\t\t\t_tableList" + table.getJavaName() + " = $('#" + table.getJavaName() +"_list').bootstrapTable({\n");

        modeldata.append("\t\t\t\t\t\turl: '${ctx}" + CreateController.urlFormapPath(htmlpath,table.getJavaName()) + "/list'  ,\n");
        modeldata.append("\t\t\t\t\t\tpagination: true,          //是否显示分页（*）\n");
        modeldata.append("\t\t\t\t\t\tpageNumber:1,            //初始化加载第一页，默认第一页\n");
        modeldata.append("\t\t\t\t\t\tpageSize: 10,            //每页的记录行数（*）\n");
        modeldata.append("\t\t\t\t\t\tsidePagination: \"server\",\n");

        modeldata.append("\t\t\t\t\t\theight: \"300\",");

        modeldata.append("\t\t\t\t\t\tpageList: [10, 25, 50],\n");

        modeldata.append("\t\t\t\t\t\tajaxOptions:{\n");
        modeldata.append("\t\t\t\t\t\t\theaders: {\"logintoken\": parent.getLoginToken()}\n");
        modeldata.append("\t\t\t\t\t\t},\n");

        //js 初始化table列表--搜索内容--开始
        modeldata.append("\t\t\t\t\t\tqueryParams: function queryParams(params) {\n");
        modeldata.append("\t\t\t\t\t\t\treturn {\n");
        modeldata.append("\t\t\t\t\t\t\t\tsortorder: params.order,\n");
        modeldata.append("\t\t\t\t\t\t\t\tsortname: params.sort,\n");
        modeldata.append("\t\t\t\t\t\t\t\tpagesize: params.limit,\n");
        modeldata.append("\t\t\t\t\t\t\t\tstart: (params.offset / params.limit) + 1,\n");
        modeldata.append(foramatSearchJs(table.getColumnList()));
        modeldata.append("\t\t\t\t\t\t\t};\n");
        modeldata.append("\t\t\t\t\t\t},\n");
        //js 初始化table列表--搜索内容--结束
        modeldata.append("\t\t\t\t\t\tresponseHandler:function(res){\n");
        modeldata.append("\t\t\t\t\t\t\treturn{\"rows\": res.data.records, \"total\": res.data.total};\n");
        modeldata.append("\t\t\t\t\t\t},\n");

        modeldata.append("\t\t\t\t\t\tcolumns: [\n");
        modeldata.append("\t\t\t\t\t\t\t{checkbox: true},\n");
        modeldata.append(formatListJs(table.getColumnList()));

        modeldata.append("\t\t\t\t\t\t\t{\n");
        modeldata.append("\t\t\t\t\t\t\t\twidth:200,\n");
        modeldata.append("\t\t\t\t\t\t\t\tfield: 'id',\n");
        modeldata.append("\t\t\t\t\t\t\t\ttitle: '操作',\n");
        modeldata.append("\t\t\t\t\t\t\t\tformatter:function(value,oData,index) {\n");
        modeldata.append("\t\t\t\t\t\t\t\t\tvar listOperation = \"\";\n");
        modeldata.append("\t\t\t\t\t\t\t\t\t$(jspOperation).each(function (i, toolbar) {\n");
        modeldata.append("\t\t\t\t\t\t\t\t\t\tlistOperation = listOperation + \"<a href=\\\"javascript:\" + toolbar.actionmethod + \"('${resourceid}\" + toolbar.methodid + \"','\" + oData.id + \"');\\\" class=\\\"btn \" + toolbar.img + \" btn-xs\\\")><i class=\\\"fa \" + toolbar.methodkey + \"\\\"></i> \" + toolbar.text + \" </a>&nbsp;&nbsp;\";\n");
        modeldata.append("\t\t\t\t\t\t\t\t\t});\n");
        modeldata.append("\t\t\t\t\t\t\t\t\treturn listOperation;\n");
        modeldata.append("\t\t\t\t\t\t\t\t}\n");
        modeldata.append("\t\t\t\t\t\t\t}\n");

        modeldata.append("\t\t\t\t\t\t]\n");

        modeldata.append("\t\t\t\t\t});\n");
        //js 初始化table列表--结束

        modeldata.append("\t\t\t\t}\n");
        //js 初始化工具按钮--结束

        modeldata.append("\t\t\t}\n");
        modeldata.append("\t\t);\n");

        modeldata.append("\t});\n");
        //js 初始化---结束


        //获取列表选中的方法 -- 开始
        modeldata.append("\tfunction getIdSelections() {\n");

        modeldata.append("\t\treturn $.map(_tableList" + table.getJavaName() + ".bootstrapTable('getSelections'), function(row) {\n");
        modeldata.append("\t\t\treturn row.id\n");
        modeldata.append("\t\t});\n");

        modeldata.append("\t}\n");
        //获取列表选中的方法 -- 结束

        //添加开始
        modeldata.append("\tfunction _useradd(jframeid){\n");

        modeldata.append("\t\tparent._xiaoyaoOpenMenuTab('${ctx}" + CreateController.urlFormapPath(htmlpath,table.getJavaName()) + "/toSave',\"添加" + table.getTableName() + "\",jframeid + '_add');\n");

        modeldata.append("\t}\n");
        //添加结束

        //修改开始
        modeldata.append("\tfunction updateData(jframeid,str){\n");
        modeldata.append("\t\tvar url = '${ctx}" + CreateController.urlFormapPath(htmlpath,table.getJavaName()) + "/toEdit/' + str ;\n");
        modeldata.append("\t\tparent._xiaoyaoOpenMenuTab(url,\"修改" + table.getTableName() + "\",jframeid + '_edit');\n");
        modeldata.append("\t}\n");

        modeldata.append("\tfunction _useredit(jframeid){\n");
        modeldata.append("\t\tvar str = getIdSelections() + \"\";\n");
        modeldata.append("\t\tvar tempstr = str.split(\",\");\n");
        modeldata.append("\t\tif(str.length > 0 && tempstr.length > 1){\n");
        modeldata.append("\t\t\tparent.toastr.error(\"每次只能修改一条信息。\");\n");
        modeldata.append("\t\t}else{\n");
        modeldata.append("\t\t\tif (str.length > 0) {\n");
        modeldata.append("\t\t\t\tupdateData(jframeid,str);\n");
        modeldata.append("\t\t\t} else {\n");
        modeldata.append("\t\t\t\tparent.toastr.error(\"至少选择一条信息操作。\");\n");
        modeldata.append("\t\t\t}\n");
        modeldata.append("\t\t}\n");

        modeldata.append("\t}\n");
        //修改结束

        //删除开始
        modeldata.append("\tfunction t_delete(str){\n");
        modeldata.append("\t\tparent.layer.closeAll('loading');\n");
        modeldata.append("\t\t\tparent.axgetXiaoyao('${ctx}" + CreateController.urlFormapPath(htmlpath,table.getJavaName()) + "/delmore' , {id:str},false, function(data){\n");
        modeldata.append("\t\t\t\tparent.layer.closeAll('loading');\n");
        modeldata.append("\t\t\t\tif(data.code == \"OK\"){\n");
        modeldata.append("\t\t\t\t\tswal(data.message, \"您已经永久删除了这条信息。\", \"success\");\n");
        modeldata.append("\t\t\t\t\trefreshTable();\n");
        modeldata.append("\t\t\t\t}else{\n");
        modeldata.append("\t\t\t\t\tswal(data.message, \"遇到未知错误！\", \"error\");\n");
        modeldata.append("\t\t\t\t}\n");
        modeldata.append("\t\t\t});\n");
        modeldata.append("\t}\n");


        modeldata.append("\tfunction _deletebu(sourceid){\n");
        modeldata.append("\t\tvar str = getIdSelections() + \"\";\n");
        modeldata.append("\t\tvar tempstr = str.split(\",\");\n");
        modeldata.append("\t\tif (str.length > 0 && tempstr.length > 0) {\n");
        modeldata.append("\t\t\tswal({\n");
        modeldata.append("\t\t\t\ttitle: \"您确定要删除这条信息吗\",\n");
        modeldata.append("\t\t\t\ttext: \"删除后将无法恢复，请谨慎操作！\",\n");
        modeldata.append("\t\t\t\ttype: \"warning\",\n");
        modeldata.append("\t\t\t\tshowCancelButton: true,\n");
        modeldata.append("\t\t\t\tconfirmButtonColor: \"#DD6B55\",\n");
        modeldata.append("\t\t\t\tconfirmButtonText: \"是的，我要删除！\",\n");
        modeldata.append("\t\t\t\tcancelButtonText: \"让我再考虑一下…\",\n");
        modeldata.append("\t\t\t\tcloseOnConfirm: false,\n");
        modeldata.append("\t\t\t\tcloseOnCancel: false\n");
        modeldata.append("\t\t\t},\n");
        modeldata.append("\t\t\tfunction (isConfirm) {\n");
        modeldata.append("\t\t\t\tif (isConfirm) {\n");
        modeldata.append("\t\t\t\t\tt_delete(str);\n");
        modeldata.append("\t\t\t\t} else {\n");
        modeldata.append("\t\t\t\t\tswal(\"已取消\", \"您取消了删除操作！\", \"error\");\n");
        modeldata.append("\t\t\t\t}\n");
        modeldata.append("\t\t\t});\n");
        modeldata.append("\t\t} else {\n");
        modeldata.append("\t\t\tparent.toastr.error(\"至少选择一条数据操作\");\n");
        modeldata.append("\t\t}\n");
        modeldata.append("\t}\n");


        modeldata.append("\tfunction _delete(sourceid,str){\n");
        modeldata.append("\t\tswal({\n");
        modeldata.append("\t\t\ttitle: \"您确定要删除这条信息吗\",\n");
        modeldata.append("\t\t\ttext: \"删除后将无法恢复，请谨慎操作！\",\n");
        modeldata.append("\t\t\ttype: \"warning\",\n");
        modeldata.append("\t\t\tshowCancelButton: true,\n");
        modeldata.append("\t\t\tconfirmButtonColor: \"#DD6B55\",\n");
        modeldata.append("\t\t\tconfirmButtonText: \"是的，我要删除！\",\n");
        modeldata.append("\t\t\tcancelButtonText: \"让我再考虑一下…\",\n");
        modeldata.append("\t\t\tcloseOnConfirm: false,\n");
        modeldata.append("\t\t\tcloseOnCancel: false\n");
        modeldata.append("\t\t},\n");
        modeldata.append("\t\tfunction (isConfirm) {\n");
        modeldata.append("\t\t\tif (isConfirm) {\n");
        modeldata.append("\t\t\t\tt_delete(str);\n");
        modeldata.append("\t\t\t} else {\n");
        modeldata.append("\t\t\t\tswal(\"已取消\", \"您取消了删除操作！\", \"error\");\n");
        modeldata.append("\t\t\t}\n");
        modeldata.append("\t\t});\n");
        modeldata.append("\t}\n");

        //删除结束


        //刷新列表开始
        modeldata.append("\tfunction refreshTable(sourceid){\n");

        modeldata.append("\t\t_tableList" + table.getJavaName() + ".bootstrapTable('refreshOptions',{pageNumber:1});\n");

        modeldata.append("\t}\n");
        //刷新列表结束

        modeldata.append("\t\n");

        modeldata.append("\t</script>\n");

        //加载js结束

        try {
            return ForFileUtil.writeFileContent(changemodelpath,modeldata.toString());
        } catch (IOException e) {
            e.printStackTrace();
        }

        return false;
    }

    /**
     *
     * 格式化字段为搜索输入框，例如：
     <div class="btn-group">
     <input name="search_loginname" id="search_loginname" class="form-control input-inline input-small" placeholder="登陆账号"/>
     </div>
     * */
    private static String foramatSearch(List<Column> columns){
        StringBuffer returndata = new StringBuffer();

        for(Column column:columns){

            //去掉主键
            if(!column.isPk()){
                //生成搜索代码
                returndata.append("\t\t\t\t\t<div class=\"form-group\">\n");

                returndata.append("\t\t\t\t\t\t\t\t" + HtmlUtils.formatSearchtype(column));

                returndata.append("\t\t\t\t\t</div>\n");
            }

        }
        return returndata.toString();
    }

    /**
     *
     * 格式化字段为搜索使用，用于数据提交，例如：
     { "name": "search_loginname", "value": '{"value":"' + $("#search_loginname").val() + '","op":"equal","type":"string"}' },
     { "name": "search_username", "value": '{"value":"' + $("#search_username").val()  + '","op":"equal","type":"string"}' },
     { "name": "search_usex", "value": '{"value":"' + $("#search_usex").val() + '","op":"equal","type":"string"}'}
     **/
    private static String foramatSearchJs(List<Column> columns){
        StringBuffer returndata = new StringBuffer();

        for(Column column:columns){
            //去掉主键
            if(!column.isPk()){
                //生成搜索代码

                String tempreturndata = "";
                //生成搜索代码

                if(StringUtils.isBlank(returndata.toString())){
                    tempreturndata = tempreturndata + "\t\t\t\t\t\t\t\t" + "search_" + column.getJavaName() + ":'{\"value\":\"' + $(\"#search_" + column.getJavaName() + "\").val() + '\",\"op\":\"equal\",\"type\":\"string\"}'";
                }else{
                    tempreturndata = tempreturndata + ",\n\t\t\t\t\t\t\t\t" + "search_" + column.getJavaName() + ":'{\"value\":\"' + $(\"#search_" + column.getJavaName() + "\").val() + '\",\"op\":\"equal\",\"type\":\"string\"}'";
                }
                returndata.append(tempreturndata);

            }
        }
        returndata.append("\n");
        return returndata.toString();
    }




    /**
     * 格式化列表中，js使用的展示
     *         { "data": "loginname"},
     { "data": "username"},
     { "data": "enabled"},
     { "data": "usex" },
     { "data": "mobile"},
     { "data": "email"},
     { "data": "departname","bSortable": false},
     { "data": "rolesname","bSortable": false},
     */
    private static String formatListJs(List<Column> columns){
        StringBuffer returndata = new StringBuffer();

        for(Column column:columns){
            //去掉主键
            if(!column.isPk()){
                returndata.append("\t\t\t\t\t\t\t\t{ width:150,valign: \"middle\",field:'" + column.getJavaName() + "',title:'" + column.getColumnName() + "',sortable:true},\n");
            }

        }
        return returndata.toString();
    }
}
