package cn.jyjz.xiaoyao.createcode.createcode.java.htmlcode;

import cn.jyjz.xiaoyao.createcode.object.Column;
import cn.jyjz.xiaoyao.createcode.object.Table;
import java.io.File;

/**
 * Created by zhangyong on 2018/3/2.
 */
public class HtmlUtils {

    //页面公用的头
    private static String getHtmlHeader(String jsppath,String tableName){
        StringBuffer header = new StringBuffer();

        header.append("<#include \"/common/taglibs.html\" />\n");
        header.append("<!DOCTYPE html>\n");

        header.append("<head>\n");
        header.append("\t<meta charset=\"utf-8\" />\n");
        header.append("\t<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\">\n");
        header.append("\t<title>" + tableName + "</title>\n");

        header.append("\n");

        header.append("\n");

        return header.toString();
    }

    //返回jsp列表页面的html头标签
    public static String getListHeader(String jsppath,String tableName){

        StringBuffer header = new StringBuffer();

        header.append(getHtmlHeader(jsppath,tableName));
        header.append("\n");

        header.append("<#include \"/head/headlist.html\" />");
        header.append("\n");

        return header.toString();
    }

    //返回jsp列表页面的html头标签
    public static String getAddHeader(String jsppath,String tableName){

        String header = getHtmlHeader(jsppath,tableName);

        header = header + "\n";

        header = header +"<#include \"/head/headaddedit.html\" />";
        return header;
    }

    /**
     * 格式化页面路径，计算出该页面与根目录的相对路径
     * */
    private static String formatJspPath(String path){
        String[] tempPath = path.split(File.separator);
        String returnpath = "../";
        for(int i = 0;i < tempPath.length ;i++){
            returnpath = returnpath + "../";
        }
        return returnpath;
    }

    /**
     * 格式化数据库表中各个搜索字段，列表页面使用
     * <input name="search_loginname" id="search_loginname" class="form-control input-inline input-small" placeholder="登陆账号"/>
     * */
    public static String formatSearchtype(Column column){

        return "<input name='search_" + column.getJavaName() + "'  id='search_" + column.getJavaName() +
            "'  class='form-control' placeholder='" + column.getColumnName() + "'/>\n";
    }

    //页面公用的尾
    public static String getBootm(){
        String bootm = "<#include \"/head/footlist.html\" />\n";

        bootm = bootm + "</body>\n";
        bootm = bootm + "</html>\n";

        return bootm;
    }
    //添加页面公用的尾
    public static String getBootmAdd(String insertScript){
        String bootm = "<#include \"/head/footadd.html\" />\n";

        bootm = bootm + insertScript;

        bootm = bootm + "</body>\n";
        bootm = bootm + "</html>\n";

        return bootm;
    }
    /**
     *
     *
     * 格式化添加页面表单,添加页面使用
     *
     * */
    public static String formatFormtype(Column column){
        StringBuffer returnstring = new StringBuffer();


        String writeMaxLength = "";

        if(null != column.getLength()){
            int codeLenth = column.getLength().intValue();
            if(codeLenth > 10){
                writeMaxLength = "maxlength='" + codeLenth/2 + "'";
            }
        }

        //字段说明

        returnstring.append("\t\t\t\t\t\t\t\t\t<div class=\"col-sm-6\">\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t\t<div class=\"form-group\">\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t\t\t<label class=\"col-sm-3 control-label is-required\">* " + column.getColumnName() + ":</label>\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t\t\t<div class=\"col-sm-9\">\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t\t\t\t<input " + formatInputNameId(column) + formatInputLtype(column) + " placeholder=\"" + column.getColumnName() + "\" class=\"form-control\" type=\"text\" " + writeMaxLength + " required>\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t\t\t</div>\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t\t</div>\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t</div>\n");

        return returnstring.toString();
    }

    /**
     *
     * 格式化输入框的name和id字段
     *
     * */
    public static String formatInputNameId(Column column){

        return " name=\"" + column.getJavaName() + "\" id=\"" + column.getJavaName()+ "\"";
    }

    /**
     *
     * 根据cdatatype类型，判断使用的输入框
     *
     * */
    public static String formatInputLtype(Column column){

        if(column.getColumnType().equals("date") || column.getColumnType().equals("datetime")){
            return " class=\"form-control layer-date\" placeholder=\"YYYY-MM-DD hh:mm:ss\" onclick=\"laydate({istime: true, format: 'YYYY-MM-DD hh:mm:ss'})\" readonly ";
        }else{
            return" class=\"form-control\"  ";
        }

    }

    /**
     * 格式化添加页面表单,修改页面使用
     * */
    public static String formatFormtypeEdit(Column column, Table table){
        StringBuffer returnstring = new StringBuffer();


        String writeMaxLength = "";

        if(null != column.getLength()){
            int codeLenth = column.getLength().intValue();
            if(codeLenth > 10){
                writeMaxLength = " maxlength='" + codeLenth/2 + "'";
            }
        }

        returnstring.append("\t\t\t\t\t\t\t\t\t<div class=\"col-sm-6\">\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t\t<div class=\"form-group\">\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t\t\t<label class=\"col-sm-3 control-label is-required\">* " + column.getColumnName() + ":</label>\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t\t\t<div class=\"col-sm-9\">\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t\t\t\t<input " + formatInputNameId(column) + formatInputLtype(column) + " placeholder=\"" + column.getColumnName() + "\" class=\"form-control\" type=\"text\" " + writeMaxLength + " required>\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t\t\t</div>\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t\t</div>\n");
        returnstring.append("\t\t\t\t\t\t\t\t\t</div>\n");



        return returnstring.toString();
    }
}
