package cn.jyjz.xiaoyao.createcode.createcode.java.javacode;


import cn.jyjz.xiaoyao.common.base.util.SnowFlakeUtil;
import cn.jyjz.xiaoyao.createcode.object.Table;
import cn.jyjz.xiaoyao.createcode.util.ForFileUtil;
import java.io.File;
import java.io.IOException;
import java.util.Date;

/**
 * Created by zhangyong on 2018/3/1.
 */
public class CreateController {

    public static final String CONTROLLER_FILE_NAME = "controller";
    /**
     *
     * physicspath：文件实际保存路径
     * table 数据库表对象
     * htmlpath html存储路径
     * */
    public static String createController(String physicspath, Table table, String javapath, String htmlpath){



        java.text.SimpleDateFormat jdf = new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        //输出内容
        StringBuffer modeldata = new StringBuffer();

        //输出内容
        StringBuffer modeldataHtml = new StringBuffer();

        //controller类名
        String controllerClassName = table.getJavaName() + "Controller";
        //controller类名
        String controllerHtmlClassName = table.getJavaName() + "HtmlController";

        //创建controller类的package路径
        String controllerjavapath = table.getJavaName().toLowerCase() + File.separator + CONTROLLER_FILE_NAME;

        controllerjavapath = ForFileUtil.formatPath(javapath) + File.separator + controllerjavapath;



        //创建controller类的物理路径
        String changemodelpath = physicspath + File.separator + controllerjavapath + File.separator + controllerClassName + ".java";

        //创建controller的html类的物理路径
        String changemodelpathHtml = physicspath + File.separator + controllerjavapath + File.separator + controllerHtmlClassName + ".java";

        modeldata.append("package " + controllerjavapath.replace(File.separator,".") + ";\n\n");

        modeldata.append("import java.io.IOException;\n");
        modeldata.append("import javax.servlet.http.HttpServletRequest;\n");
        modeldata.append("import javax.servlet.http.HttpServletResponse;\n");
        modeldata.append("import com.alibaba.fastjson.JSONObject;\n");
        modeldata.append("import org.slf4j.Logger;\n");
        modeldata.append("import org.slf4j.LoggerFactory;\n");
        modeldata.append("import org.springframework.beans.factory.annotation.Autowired;\n");
        modeldata.append("import org.springframework.web.bind.annotation.RestController;\n");
        modeldata.append("import org.springframework.web.bind.annotation.*;\n\n");

        modeldata.append("import cn.jyjz.xiaoyao.admin.service.UserService;\n");
        modeldata.append("import cn.jyjz.xiaoyao.common.base.service.UserTokenService;\n");
        modeldata.append("import cn.jyjz.xiaoyao.common.base.controller.BaseController;\n");
        modeldata.append("import cn.jyjz.xiaoyao.common.base.param.ParamterPage;\n");
        modeldata.append("import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;\n");
        modeldata.append("import cn.jyjz.xiaoyao.common.base.vo.ResultVo;\n");
        modeldata.append("import cn.jyjz.xiaoyao.common.base.vo.ResultVoUtil;\n");
        modeldata.append("import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;\n");
        modeldata.append("import com.baomidou.mybatisplus.core.metadata.IPage;\n");

        modeldata.append("import " + (CreateModel.getRelativepath(table.getJavaName(),javapath) + File.separator + table.getJavaName()).replace(File.separator,".") +";\n");

        modeldata.append("import " + (CreateService.getRelativepath(table.getJavaName(),javapath) + File.separator + CreateService.getServiceName(table.getJavaName())).replace(File.separator,".") + ";\n\n");

        modeldata.append("@RestController\n");
        modeldata.append("@RequestMapping(\"" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase()) + "\")\n");
        modeldata.append("public class " + controllerClassName + " extends BaseController{\n\n");
        modeldata.append("\tprivate Logger log = LoggerFactory.getLogger(this.getClass());\n\n");
        modeldata.append("\t@Autowired\n");
        modeldata.append("\tprivate " + CreateService.getServiceName(table.getJavaName()) + " " + CreateService.getServiceName(table.getJspName()) + ";\n\n");

        modeldata.append("\t@Autowired\n");
        modeldata.append("\tprivate UserTokenService userTokenService;\n");

        modeldata.append("\t@Autowired\n");
        modeldata.append("\tprivate UserService userService;\n");

        //返回json字符串，接受参数，dto名称以及分页信息
        modeldata.append("\t/**\n\t*方法描述：返回json字符串，接受参数，dto名称以及分页信息\n\t*创建人：mail.zhangyong@gmail.com\n\t*创建时间：" +  jdf.format(new Date()) + "\n\t**/\n");
        modeldata.append("\t@GetMapping(\"/list" + "\")\n");
        modeldata.append("\tpublic ResultVo<IPage<" + table.getJavaName() + ">> list" + table.getJavaName() + "(ParamterPage paramterPage,HttpServletRequest request,HttpServletResponse response) throws IOException{\n");
        modeldata.append("\t\tSearchQuery searchQuery = this.getParametersStartingWithToSearchJson(request, \"search_\");\n");
        modeldata.append("\t\tUserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(request));\n");


        modeldata.append("\t\tcn.jyjz.xiaoyao.admin.dataobject.User user = this.userService.getSessionUser(request);\n");
        modeldata.append("\t\t" + table.getJavaName() + " " + table.getJavaName().toLowerCase() +  " = new " + table.getJavaName() + "();\n");
        modeldata.append("\t\t" + table.getJavaName().toLowerCase() + ".setSearchQueryrolesShowleave(user.getSearchQueryrolesShowleave());\n");


        modeldata.append("\t\tQueryWrapper<" + table.getJavaName() +"> queryWrapper = SearchQueryFormat.queryStringFormat(searchQuery," + table.getJavaName().toLowerCase() +");\n");


        modeldata.append("\t\tIPage<" + table.getJavaName() + "> page = this." + CreateService.getServiceName(table.getJspName()) + ".selectSearchListPage(paramterPage,queryWrapper);;\n");


        modeldata.append("\t\treturn ResultVoUtil.success(page);\n");
        modeldata.append("\t}\n\n");


        //保存添加数据
        modeldata.append("\t/**\n\t*方法描述：保存添加数据\n\t*创建人：mail.zhangyong@gmail.com\n\t*创建时间：" +  jdf.format(new Date()) + "\n\t**/\n");
        modeldata.append("\t@PostMapping(\"/save\")\n");
        modeldata.append("\tpublic ResultVo save" + table.getJavaName() + "(HttpServletResponse response,HttpServletRequest request," + table.getJavaName() + " tab) throws IOException{\n");
        modeldata.append("\t\tUserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(request));\n");
//        modeldata.append("\t\ttab.setCreateuser(user.getLoginname());\n");
//        modeldata.append("\t\ttab.setDeptid(user.getDepartmentId());\n");
        modeldata.append("\t\ttab.setCreatedate(System.currentTimeMillis());\n");

        modeldata.append("\t\tthis." + CreateService.getServiceName(table.getJspName()) + ".save" + "(tab);\n");
        modeldata.append("\t\treturn ResultVoUtil.success();\n");
        modeldata.append("\t}\n\n");


        //修改数据
        modeldata.append("\t/**\n\t*方法描述：根据页面form传来的对象修改数据\n\t*创建人：mail.zhangyong@gmail.com\n\t*创建时间：" +  jdf.format(new Date()) + "\n\t**/\n");
        modeldata.append("\t@PostMapping(\"/edit\")\n");
        modeldata.append("\tpublic ResultVo edit" + table.getJavaName() + "(HttpServletResponse response,HttpServletRequest request," + table.getJavaName() + " tab) throws IOException{\n");

        modeldata.append("\t\tUserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(request));\n");
//        modeldata.append("\t\ttab.setUpdateuser(user.getLoginname());\n");
//        modeldata.append("\t\ttab.setUpdatetime(new Date());\n");

        modeldata.append("\t\tthis." + CreateService.getServiceName(table.getJspName()) + ".updateById(tab);\n");
        modeldata.append("\t\treturn ResultVoUtil.success();\n");
        modeldata.append("\t}\n\n");

        //通过主键获得对象信息
        modeldata.append("\t/**\n\t*方法描述：通过主键获得对象信息\n\t*创建人：mail.zhangyong@gmail.com\n\t*创建时间：" + jdf.format(new Date()) + "\n\t**/\n");
        modeldata.append("\t@GetMapping(\"/getdata" + "/{id}\")\n");
        modeldata.append("\t@ResponseBody\n");
        modeldata.append("\tpublic ResultVo getdate" + table.getJavaName() + "(HttpServletResponse response,HttpServletRequest request,@PathVariable(\"id\") Long id) throws IOException{\n");
        modeldata.append("\t\t" + table.getJavaName() + " dto = this." + CreateService.getServiceName(table.getJspName()) + ".selectDtoById(id)" + ";\n");
        modeldata.append("\t\tif(null != dto){\n");
        modeldata.append("\t\t\treturn ResultVoUtil.success(dto);\n");
        modeldata.append("\t\t}else{\n");
        modeldata.append("\t\t\treturn ResultVoUtil.error();\n");
        modeldata.append("\t\t}\n");
        modeldata.append("\t}\n\n");


        //删除多条数据
        modeldata.append("\t/**\n\t*方法描述：根据id字符串组删除对象方法，例如1,2,3\n\t*创建人：mail.zhangyong@gmail.com\n\t*创建时间：" + jdf.format(new Date()) + "\n\t**/\n");
        modeldata.append("\t@GetMapping(\"/delmore\")\n");
        modeldata.append("\t@ResponseBody\n");
        modeldata.append("\tpublic ResultVo delMore" + table.getJavaName() + "(HttpServletResponse response,HttpServletRequest request) throws IOException{\n");
        modeldata.append("\t\tString ids = request.getParameter(\"id\");\n");
        modeldata.append("\t\tthis." + CreateService.getServiceName(table.getJspName()) + ".deleteByIdMore(ids);\n");
        modeldata.append("\t\treturn ResultVoUtil.success();\n");
        modeldata.append("\t}\n\n");

        modeldata.append("}");


        //-------------------html Controller
        modeldataHtml.append("package " + controllerjavapath.replace(File.separator,".") + ";\n\n");

        modeldataHtml.append("import java.io.IOException;\n");
        modeldataHtml.append("import javax.servlet.http.HttpServletRequest;\n");
        modeldataHtml.append("import javax.servlet.http.HttpServletResponse;\n");
        modeldataHtml.append("import com.alibaba.fastjson.JSONObject;\n");
        modeldataHtml.append("import org.slf4j.Logger;\n");
        modeldataHtml.append("import org.slf4j.LoggerFactory;\n");
        modeldataHtml.append("import org.springframework.beans.factory.annotation.Autowired;\n");
        modeldataHtml.append("import org.springframework.stereotype.Controller;\n");
        modeldataHtml.append("import org.springframework.web.bind.annotation.*;\n\n");


        modeldataHtml.append("import cn.jyjz.xiaoyao.admin.service.UserService;\n");
        modeldataHtml.append("import cn.jyjz.xiaoyao.common.base.service.UserTokenService;\n");
        modeldataHtml.append("import cn.jyjz.xiaoyao.common.base.controller.BaseController;\n");
        modeldataHtml.append("import cn.jyjz.xiaoyao.common.base.param.ParamterPage;\n");
        modeldataHtml.append("import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;\n");
        modeldataHtml.append("import cn.jyjz.xiaoyao.common.base.vo.ResultVo;\n");
        modeldataHtml.append("import cn.jyjz.xiaoyao.common.base.vo.ResultVoUtil;\n");
        modeldataHtml.append("import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;\n");
        modeldataHtml.append("import com.baomidou.mybatisplus.core.metadata.IPage;\n");

        modeldataHtml.append("import " + (CreateModel.getRelativepath(table.getJavaName(),javapath) + File.separator + table.getJavaName()).replace(File.separator,".") +";\n");

        modeldataHtml.append("import " + (CreateService.getRelativepath(table.getJavaName(),javapath) + File.separator + CreateService.getServiceName(table.getJavaName())).replace(File.separator,".") + ";\n\n");

        modeldataHtml.append("@Controller\n");
        modeldataHtml.append("@RequestMapping(\"" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase()) + "Html\")\n");
        modeldataHtml.append("public class " + table.getJavaName() + "HtmlController" + " extends BaseController{\n\n");
        modeldataHtml.append("\tprivate Logger log = LoggerFactory.getLogger(this.getClass());\n\n");
        modeldataHtml.append("\t@Autowired\n");
        modeldataHtml.append("\tprivate " + CreateService.getServiceName(table.getJavaName()) + " " + CreateService.getServiceName(table.getJspName()) + ";\n\n");

        modeldataHtml.append("\t@Autowired\n");
        modeldataHtml.append("\tprivate UserTokenService userTokenService;\n");

        modeldataHtml.append("\t@Autowired\n");
        modeldataHtml.append("\tprivate UserService userService;\n");

        //跳转到列表页面

        modeldataHtml.append("\t/**\n\t*方法描述：跳转到列表页面\n\t*创建人：mail.zhangyong@gmail.com\n\t*创建时间：" +  jdf.format(new Date()) + "\n\t**/\n");
        modeldataHtml.append("\t@GetMapping(\"/toList\")\n");
        modeldataHtml.append("\tpublic String toList" + table.getJavaName() + "(HttpServletResponse response,HttpServletRequest request){\n");

        modeldataHtml.append( "\t\tString resourceid = request.getParameter(\"resourceid\");\n");
        modeldataHtml.append("\t\trequest.setAttribute(\"resourceid\",resourceid);\n");

        modeldataHtml.append("\t\treturn \"" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase()) + "/list\";\n");
        modeldataHtml.append("\t}\n\n");

        //跳转到保存页面
        modeldataHtml.append("\t/**\n\t*方法描述：跳转到保存页面\n\t*创建人：mail.zhangyong@gmail.com\n\t*创建时间：" +  jdf.format(new Date()) + "\n\t**/\n");
        modeldataHtml.append("\t@GetMapping(\"/toSave\")\n");
        modeldataHtml.append("\tpublic String toSave" + table.getJavaName() + "(HttpServletResponse response,HttpServletRequest request){\n");
        modeldataHtml.append( "\t\tString resourceid = request.getParameter(\"resourceid\");\n");
        modeldataHtml.append("\t\trequest.setAttribute(\"resourceid\",resourceid);\n");
        modeldataHtml.append("\t\treturn \"" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase()) + "/add\";\n");
        modeldataHtml.append("\t}\n\n");

        //跳转到修改页面
        modeldataHtml.append("\t/**\n\t*方法描述：根据ID跳转到修改页面\n\t*创建人：mail.zhangyong@gmail.com\n\t*创建时间：" +  jdf.format(new Date()) + "\n\t**/\n");
        modeldataHtml.append("\t@GetMapping(\"/toEdit" + "/{id}\")\n");
        modeldataHtml.append("\tpublic String toEdit" + table.getJavaName() + "(HttpServletResponse response,HttpServletRequest request,@PathVariable(\"id\") String id){\n");

        modeldataHtml.append( "\t\tString resourceid = request.getParameter(\"resourceid\");\n");
        modeldataHtml.append("\t\trequest.setAttribute(\"resourceid\",resourceid);\n");
        modeldataHtml.append("\t\trequest.setAttribute(\"id\", id);\n");
        modeldataHtml.append("\t\treturn \"" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase()) + "/edit\";\n");
        modeldataHtml.append("\t}\n\n");

        modeldataHtml.append("}");


        try {
            ForFileUtil.writeFileContent(changemodelpath,modeldata.toString());
            ForFileUtil.writeFileContent(changemodelpathHtml,modeldataHtml.toString());
        } catch (IOException e) {
            e.printStackTrace();
        }

        Long tempid = SnowFlakeUtil.nextId();
        String returnsql = "INSERT INTO S_RESOURCES_T(ID,RESOURCENAME,RPARENTID,ROOTID,RESOURCETYPE,PRIORITYPE,RESOURCE,RESOURCELIST,RESOURCEDESC,ENABLED,RIOCNIMAGE) " +
            "VALUES (" + tempid + ",'" + table.getTableName() + "',1,1, '1', '5','" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase()) + "Html/toList','" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase()) + "/list"  + "','" + table.getTableName() + "', '1', 'icon-diamond');\n";

        returnsql = returnsql + "INSERT INTO S_RESOURCEMETHOD_T (RESOURCEID,METHODID,RESOURCEBEFOR,RESOURCEAFTER) VALUES (" + tempid + ", '101','" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase())   + "Html/toSave','" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase())   + "/save');\n";
        returnsql = returnsql + "INSERT INTO S_RESOURCEMETHOD_T (RESOURCEID,METHODID,RESOURCEBEFOR,RESOURCEAFTER) VALUES (" + tempid + ", '102','" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase())   + "Html/toEdit','" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase())   + "/edit');\n";
        returnsql = returnsql + "INSERT INTO S_RESOURCEMETHOD_T (RESOURCEID,METHODID,RESOURCEBEFOR,RESOURCEAFTER) VALUES (" + tempid + ", '103','" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase())   + "/delmore',null);\n";
        returnsql = returnsql + "INSERT INTO S_RESOURCEMETHOD_T (RESOURCEID,METHODID,RESOURCEBEFOR,RESOURCEAFTER) VALUES (" + tempid + ", '104','" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase())  + "/getdata',null);\n";
        returnsql = returnsql + "INSERT INTO S_RESOURCEMETHOD_T (RESOURCEID,METHODID,RESOURCEBEFOR,RESOURCEAFTER) VALUES (" + tempid + ", '111','" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase())   + "Html/toEdit','" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase())   + "/edit');\n";
        returnsql = returnsql + "INSERT INTO S_RESOURCEMETHOD_T (RESOURCEID,METHODID,RESOURCEBEFOR,RESOURCEAFTER) VALUES (" + tempid + ", '112','" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase())   + "/delone',null);\n";


        returnsql = returnsql + "INSERT INTO S_BACKSTAGEOPENURL_T(ID,URL,REMARK) VALUES(" + SnowFlakeUtil.nextId() + ", '" + urlFormapPath(htmlpath,table.getJavaName().toLowerCase()) + "/getdata', '获取对象信息');\n";

        return returnsql;
    }

    public static String urlFormapPath(String dtoClassName) {
        String returnurl = "/backstage/" + dtoClassName.toLowerCase();
        return returnurl;
    }

    /**
     * 增加url的相对路径
     * @param path
     * @param dtoClassName
     * @return
     */
    public static String urlFormapPath(String path,String dtoClassName) {
    
        path = path.replaceAll("\\\\", "/");
        
        String returnurl = "/" + path + "/" + dtoClassName.toLowerCase();
        return returnurl;
    }
}
