package cn.jyjz.xiaoyao.createcode.enums;

/**
 * Created by zhangyong on 2018/2/6.
 */
public enum JavaTypeEnum {

    CHAR("CHAR", "String"),
    VARCHAR("VARCHAR", "String"),
    LONGVARCHAR("LONGVARCHAR", "String"),
    NUMERIC("NUMERIC", "java.math.BigDecimal"),
    DECIMAL("DECIMAL", "java.math.BigDecimal"),
    BIT("BIT", "boolean"),
    TINYINT("TINYINT", "byte"),
    SMALLINT("SMALLINT", "short"),
    INTEGER("INTEGER", "Integer"),
    INT("INT", "Integer"),
    BIGINT("BIGINT", "Long"),
    REAL("REAL", "float"),
    FLOAT("FLOAT", "double"),
    DOUBLE("DOUBLE", "double"),
    BINARY("BINARY", "byte[]"),
    VARBINARY("VARBINARY", "byte[]"),
    LONGVARBINARY("LONGVARBINARY", "byte[]"),
    DATE("DATE", "java.util.Date"),
    DATETIME("DATETIME", "java.util.Date"),
    TIME("TIME", "java.sql.Time"),
    TIMESTAMP("TIMESTAMP", "java.util.Date"),
    TEXT("TEXT", "String"),
    TINYTEXT("TINYTEXT", "String"),
    MEDIUMTEXT("MEDIUMTEXT", "String"),
    LONGTEXT("LONGTEXT", "String"),
    BLOB("BLOB", "byte[]"),
    MEDIUMBLOB("MEDIUMBLOB", "byte[]"),
    LONGBLOB("LONGBLOB", "byte[]"),
    TINYBLOB("TINYBLOB", "byte[]");
    // 成员变量
    private String datatype;
    private String javatype;

    // 构造方法
    private JavaTypeEnum(String datatype, String javatype) {

        this.datatype = datatype;
        this.javatype = javatype;
    }

    // 普通方法
    public static String getJavaType(String datatype) {
        for (JavaTypeEnum c : JavaTypeEnum.values()) {
            if (c.getDatatype().equals(datatype)) {
                return c.javatype;
            }
        }
        return datatype;
    }

    public String getDatatype() {
        return datatype;
    }

    public void setDatatype(String datatype) {
        this.datatype = datatype;
    }

    public String getJavatype() {
        return javatype;
    }

    public void setJavatype(String javatype) {
        this.javatype = javatype;
    }

}
