package cn.jyjz.xiaoyao.createcode.enums;

/**
 * Created by zhangyong on 2018/3/2.
 */
public enum JdbcTypeEnum {

    CHAR("CHAR", "CHAR"),
    VARCHAR("VARCHAR", "VARCHAR"),
    LONGVARCHAR("LONGVARCHAR", "VARCHAR"),
    NUMERIC("NUMERIC", "NUMERIC"),
    DECIMAL("DECIMAL", "DECIMAL"),
    BIT("BIT", "BIT"),
    TINYINT("TINYINT", "TINYINT"),
    SMALLINT("SMALLINT", "SMALLINT"),
    INTEGER("INTEGER", "INTEGER"),
    INT("INT", "INTEGER"),
    BIGINT("BIGINT", "BIGINT"),
    REAL("REAL", "REAL"),
    FLOAT("FLOAT", "FLOAT"),
    DOUBLE("DOUBLE", "DOUBLE"),
    BINARY("BINARY", "BINARY"),
    VARBINARY("VARBINARY", "VARBINARY"),
    LONGVARBINARY("LONGVARBINARY", "LONGVARBINARY"),
    DATE("DATE", "DATE"),
    DATETIME("DATETIME", "TIMESTAMP"),
    TIME("TIME", "TIME"),
    TIMESTAMP("TIMESTAMP", "TIMESTAMP"),
    TEXT("TEXT", "LONGVARCHAR"),
    TINYTEXT("TINYTEXT", "LONGVARCHAR"),
    MEDIUMTEXT("MEDIUMTEXT", "LONGVARCHAR"),
    LONGTEXT("LONGTEXT", "LONGVARCHAR"),
    BLOB("BLOB", "BLOB"),
    MEDIUMBLOB("MEDIUMBLOB", "MEDIUMBLOB"),
    LONGBLOB("LONGBLOB", "LONGBLOB"),
    TINYBLOB("TINYBLOB", "TINYBLOB");
    // 成员变量
    private String datatype;
    private String jdbctype;

    // 构造方法
    private JdbcTypeEnum(String datatype, String jdbctype) {
        this.datatype = datatype;
        this.jdbctype = jdbctype;
    }

    // 普通方法
    public static String getJdbcType(String datatype) {
        for (JdbcTypeEnum c : JdbcTypeEnum.values()) {
            if (c.getDatatype().equals(datatype)) {
                return c.getJdbctype();
            }
        }
        return datatype;
    }

    public String getDatatype() {
        return datatype;
    }

    public void setDatatype(String datatype) {
        this.datatype = datatype;
    }

    public String getJdbctype() {
        return jdbctype;
    }

    public void setJdbctype(String jdbctype) {
        this.jdbctype = jdbctype;
    }
}
