package cn.jyjz.xiaoyao.createcode.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by zhangyong on 2018/2/8.
 */
public class ForFileUtil {

    private static Logger logger = LoggerFactory.getLogger(ForFileUtil.class);
    /**
     * 格式化相对路径
     * @param tempPath
     * @return 去掉路径上头和尾部的分隔符
     */
    public static String formatPath(String tempPath){

        logger.info("tempPath={}",tempPath);
        logger.info("File.separator={}",File.separator);

        tempPath = tempPath.replace("/",File.separator);

        if(tempPath.endsWith(File.separator)){
            tempPath = tempPath.substring(0,tempPath.length() - 1);
        }

        //去掉路径上第一个分隔符
        if(tempPath.startsWith(File.separator)){
            tempPath = tempPath.substring(1,tempPath.length());
        }
        return tempPath;
    }

    /**
     * 格式化表名，去掉表名第一个下划线下划线之前的字符串，去掉表名第二个下划线之后的字符串
     * @param tablename
     * @return
     * @throws IOException
     */
    public static String tableFormatName(String tablename) {

        //tablename = tablename.substring(tablename.indexOf("_")+1,tablename.lastIndexOf("_"));

        return tablename;
    }

    /**
     * 向文件中写入内容
     * @param filepath 文件路径与名称
     * @param newstr  写入的内容
     * @return
     * @throws IOException
     */
    public static boolean writeFileContent(String filepath,String newstr) throws IOException {
        Boolean bool = false;
        String filein = newstr+"\r\n";//新写入的行，换行
        String temp  = "";

        FileInputStream fis = null;
        InputStreamReader isr = null;
        BufferedReader br = null;
        FileOutputStream fos  = null;
        PrintWriter pw = null;
        try {
            File file = new File(filepath);//文件路径(包括文件名称)

            if(!file.exists()){

                file.getParentFile().mkdirs();
                file.createNewFile();
            }

            //将文件读入输入流
            fis = new FileInputStream(file);
            isr = new InputStreamReader(fis);
            br = new BufferedReader(isr);
            StringBuffer buffer = new StringBuffer();

            //文件原有内容
            for(int i=0;(temp =br.readLine())!=null;i++){
                buffer.append(temp);
                // 行与行之间的分隔符 相当于“\n”
                buffer = buffer.append(System.getProperty("line.separator"));
            }
            buffer.append(filein);

            fos = new FileOutputStream(file);
            pw = new PrintWriter(fos);
            pw.write(buffer.toString().toCharArray());
            pw.flush();
            bool = true;
        } catch (Exception e) {
            // TODO: handle exception
            e.printStackTrace();
        }finally {
            //不要忘记关闭
            if (pw != null) {
                pw.close();
            }
            if (fos != null) {
                fos.close();
            }
            if (br != null) {
                br.close();
            }
            if (isr != null) {
                isr.close();
            }
            if (fis != null) {
                fis.close();
            }
        }
        return bool;
    }
}
